package com.izenpe.zain.cliente.pdf;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;

import org.apache.axis.encoding.Base64;
import org.oasis_open.docs.www.dss._2004._06.oasis_dss_1_0_core_schema_wd_27_xsd.VerifyResponse;

import com.izenpe.zain.client.ZainConfig;
import com.izenpe.zain.cliente.util.Constantes;
import com.izenpe.zain.cliente.util.Propiedades;
import com.izenpe.zain.cliente.util.ZainUtil;
import com.safelayer.trustedx.client.smartwrapper.Constants;
import com.safelayer.trustedx.client.smartwrapper.SmartVerifyRequest;
import com.safelayer.trustedx.client.smartwrapper.SmartVerifyResponse;
import com.safelayer.www.TWS.TimeStampValues;

public class VerificacionFirmaPDF {
	// Nombre del fichero cuya firma va a ser verificada.
	private static final String signName = "PruebaPDFSignedTS.pdf";

	public static void main(String args[]) {
		try {

			ZainConfig.setCurrent(Propiedades.ZAIN_CONFIG);
			/*
			 * Se crea la petición a través de la URL definida en ZAIN_ENDPOINT.
			 */
			SmartVerifyRequest smartVerifyReq = new SmartVerifyRequest(Propiedades.ZAIN_ENDPOINT);

			// Se establece el perfil PDF en la petición de Verificación
			// de firma.
			smartVerifyReq.setProfile(Constants.Profile.PDF);

			/*
			 * Se establece el idioma de la petición en español. 2
			 * posibilidades: 1. Español: 'es' 2. Inglés: 'en'
			 */
			smartVerifyReq.setLanguage("es");

			// Datos a verificar.
			smartVerifyReq.setInputPdfBase64Data(Base64.encode(ZainUtil.readBinaryFile("data/output/" + signName)));
			
			/*
			 * Se solicita en la petición de Verificación que se añadan a la
			 * respuesta los valores de la TSA(Informacion del sello de tiempo).
			 */
			smartVerifyReq.setAddTimeStampValues(Constants.AddValues.SIMPLE);

			// Envío de la petición.
			SmartVerifyResponse smartVerifyResp = smartVerifyReq.send();

			// Se comprueba la validez de la respuesta de Verificación de firma
			// PDF
			if (Constantes.RMAJOR_SUCCESS.equals((smartVerifyResp.getResultMajor()))
					&& Constantes.RMINOR_SUCCESS.equals(smartVerifyResp.getResultMinor())) {
				System.out.println("La firma ha sido verificada con éxito.");
				VerifyResponse verifyResponseAxis = (VerifyResponse)smartVerifyResp.getInternalObject();
				TimeStampValues timeStampValues = verifyResponseAxis.getOptionalOutputs().getTimeStampValues();
				if (timeStampValues != null) {
					Calendar creationTime = timeStampValues.getTimeStampValue()[0].getTstInfo().getCreationTime();
					DateFormat df = SimpleDateFormat.getDateTimeInstance();
					System.out.println("Hora obtenida de la TSA: " + df.format(creationTime.getTime()));
				}
			} else {
				System.out.println("La firma tiene errores: " + smartVerifyResp.getResultMessage());
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}